
using System;
using System.Data.SqlClient;
    using Microsoft.SqlServer.Server;

    public class FirstSQLCLR
    {
        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void ListEmployees()
        {
            SqlContext.Pipe.Send("Current Contacts as of: " +
                                 System.DateTime.Now.ToString() + "\n");
            using (SqlConnection conn = 
                new SqlConnection("context connection=true"))
            {
                conn.Open();
                SqlCommand cmd = new SqlCommand(
                    "SELECT Person.Contact.LastName, Person.Contact.FirstName, " +
                    "Person.Contact.EmailAddress, HumanResources.Employee.HireDate " +
                    "FROM Person.Contact Inner Join HumanResources.Employee " +
                    "On Person.Contact.ContactID = HumanResources.Employee.ContactID " +
                    "ORDER BY LastName, FirstName", conn);
                SqlDataReader rdr = cmd.ExecuteReader();
                SqlContext.Pipe.Send(rdr);
            }
        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void ListEmployeesWithVariable
            (System.Data.SqlTypes.SqlString orderBy)
        {
            SqlContext.Pipe.Send("Current Contacts as of: " +
                                 System.DateTime.Now.ToString() + "\n");
            using (SqlConnection conn = 
                new SqlConnection("context connection=true"))
            {
                conn.Open();
                SqlCommand cmd = new SqlCommand
                    ("SELECT Person.Contact.LastName, Person.Contact.FirstName, " +
                    "Person.Contact.EmailAddress, HumanResources.Employee.HireDate " +
                    "FROM Person.Contact Inner Join HumanResources.Employee " +
                    "On Person.Contact.ContactID = HumanResources.Employee.ContactID " +
                    "ORDER BY " + orderBy.ToString(), conn);
                SqlDataReader rdr = cmd.ExecuteReader();
                SqlContext.Pipe.Send(rdr);
            }
        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void ControllingProgramFlow(System.Data.SqlTypes.SqlInt32 chooseFieldsToUse, System.Data.SqlTypes.SqlInt32 chooseOrderBy)
        {
            SqlContext.Pipe.Send("Current Contacts as of: " +
                                 System.DateTime.Now.ToString() + "\n");
            using (SqlConnection conn = new SqlConnection("context connection=true"))
            {
                conn.Open();
                
                string sql = "Select ";
                
                // First way to control flow of program, switch...case code block.
                switch((int) chooseFieldsToUse)
                {
                    case 1:
                        sql += "Person.Contact.LastName, Person.Contact.FirstName, Person.Contact.EmailAddress, HumanResources.Employee.HireDate";
                        break;
                    
                    case 2:
                        sql += "Person.Contact.LastName, Person.Contact.FirstName, HumanResources.Employee.Title, HumanResources.Employee.BirthDate";
                        break;

                    case 3:
                        sql += "Person.Contact.LastName, Person.Contact.FirstName, HumanResources.Employee.MaritalStatus, HumanResources.Employee.Gender";
                        break;
                }

                sql += " FROM Person.Contact Inner Join HumanResources.Employee On Person.Contact.ContactID = HumanResources.Employee.ContactID ORDER BY ";  
                
                // Another way, using the if...else code block.
                if(chooseOrderBy == 1)
                    sql += "LastName, FirstName";
                else
                    sql += "HireDate";

                SqlCommand cmd = new SqlCommand(sql, conn);
                SqlDataReader rdr = cmd.ExecuteReader();
                SqlContext.Pipe.Send(rdr);
            }
        }
        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void ListEmployeesUsingInputParameter
            (System.Data.SqlTypes.SqlString searchLastName)
        {
            SqlContext.Pipe.Send("Current Contacts as of: " +
                                 System.DateTime.Now.ToString() + "\n");
            using (SqlConnection conn = new SqlConnection
                ("context connection=true"))
            {
                conn.Open();
                SqlCommand cmd = new SqlCommand
                    ("SELECT Person.Contact.LastName, " +
                    "Person.Contact.FirstName, Person.Contact.EmailAddress, " + 
                    "HumanResources.Employee.HireDate " + 
                    "FROM Person.Contact Inner Join HumanResources.Employee " + 
                    "On Person.Contact.ContactID = HumanResources.Employee.ContactID " + 
                    "Where Person.Contact.LastName Like @LastName", conn);
                cmd.Parameters.Add(new SqlParameter
                    ("@LastName",System.Data.SqlDbType.NVarChar, 2));
                cmd.Parameters[0].Value = searchLastName;

                SqlDataReader rdr = cmd.ExecuteReader();
                SqlContext.Pipe.Send(rdr);
            }

        }
        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void ListEmployeesUsingOutputParameter
            (System.Data.SqlTypes.SqlString productNumber, 
            System.Data.SqlTypes.SqlString color)
        {
            using (SqlConnection conn = new SqlConnection
                ("context connection=true"))
            {
                conn.Open();

                string sql = "IF @ProductNumber IS Null"; 
	            sql += "    BEGIN";
	            sql += "        SELECT Name FROM Production.Product " + 
                    "WHERE Color = @Color";
	            sql += "        SELECT @MyMessage = 'No Product Number'";
	            sql += "    END ";
                sql += "ELSE";
	            sql += "    BEGIN";
                sql += "        SELECT Name FROM Production.Product " + 
                    "WHERE ProductNumber = @ProductNumber";
	            sql += "        SELECT @MyMessage = 'Product Number Supplied'";
	            sql += "    END ";
                sql += "SELECT @MyMessage";

                
                SqlCommand cmd = new SqlCommand(sql, conn);
                
                cmd.Parameters.Add(new SqlParameter
                    ("@ProductNumber", System.Data.SqlDbType.VarChar, 25));
                cmd.Parameters[0].Value = productNumber;
                cmd.Parameters.Add(new SqlParameter
                    ("@Color", System.Data.SqlDbType.VarChar, 15));
                cmd.Parameters[1].Value = color;
                cmd.Parameters.Add(new SqlParameter
                    ("@MyMessage", System.Data.SqlDbType.VarChar, 50));
                cmd.Parameters[2].Direction = 
                    System.Data.ParameterDirection.Output;
                
                SqlDataReader rdr = cmd.ExecuteReader();
                SqlContext.Pipe.Send(rdr);
            }

        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void UsingTemporaryTables()
        {
            using (SqlConnection conn = 
                new SqlConnection("context connection=true"))
            {
                conn.Open();

                string sql = "CREATE TABLE #TempContacts";
                sql += "        (ContactID int NOT NULL PRIMARY KEY, ";
                sql += "        LastName varchar(50),";
                sql += "        FirstName varchar(50))";
                sql += "  INSERT INTO #TempContacts ";
                sql += "  (ContactID, LastName, FirstName) ";
                sql += "  SELECT Person.Contact.ContactID, ";
                sql += "  Person.Contact.LastName, Person.Contact.FirstName ";
                sql += "  FROM Person.Contact";
                sql += "  SELECT LastName, FirstName ";
                sql += "  FROM #TempContacts ORDER BY LastName, FirstName";


                SqlCommand cmd = new SqlCommand(sql, conn);

                SqlDataReader rdr = cmd.ExecuteReader();
                SqlContext.Pipe.Send(rdr);
            }

        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void HandlingRuntimeErrors
            (System.Data.SqlTypes.SqlString departmentName, 
            System.Data.SqlTypes.SqlString groupName)
        {
            if (groupName.IsNull)
                // Error handled in C#
                SqlContext.Pipe.Send("Group Name must be filled in.");
            else
            {
                using (SqlConnection conn = 
                    new SqlConnection("context connection=true"))
                {
                    conn.Open();
                    // Error handled in T-SQL
                    string sql = "IF @DepartmentName Is Null ";
                    sql += "    BEGIN ";
                    sql += "        SELECT Message = 'No Department Name', ";
                    sql += "        DepartmentID = 0";
                    sql += "    END ";
                    sql += "ELSE ";
                    sql += "    BEGIN ";
                    sql += "        INSERT INTO HumanResources.Department";
                    sql += "        (Name, GroupName) VALUES (@DepartmentName, @GroupName) ";
                    sql += "        SELECT Message = 'Success', DepartmentID = @@Identity ";
                    sql += "    END ";

                    SqlCommand cmd = new SqlCommand(sql, conn);
                    cmd.Parameters.Add(new SqlParameter
                        ("@DepartmentName", System.Data.SqlDbType.VarChar, 50));
                    cmd.Parameters[0].Value = departmentName;
                    cmd.Parameters.Add(new SqlParameter
                        ("@GroupName", System.Data.SqlDbType.VarChar, 50));
                    cmd.Parameters[1].Value = groupName;

                    SqlDataReader rdr = cmd.ExecuteReader();
                    SqlContext.Pipe.Send(rdr);

                }
            }
        }
        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void RaisingErrors
            (System.Data.SqlTypes.SqlString departmentName, 
            System.Data.SqlTypes.SqlString groupName)
        {
            try
            {
                using (SqlConnection conn = 
                    new SqlConnection("context connection=true"))
                {
                    conn.Open();
                    string sql = "SET NOCOUNT ON "; 
                    sql += "INSERT INTO HumanResources.Department(Name, GroupName) ";
                    sql += "VALUES (@DepartmentName, @GroupName) ";
                    sql += "SELECT DepartmentID = @@Identity";

                    SqlCommand cmd = new SqlCommand(sql, conn);
                    cmd.Parameters.Add(new SqlParameter("@DepartmentName", 
                        System.Data.SqlDbType.VarChar, 50));
                    cmd.Parameters[0].Value = departmentName;
                    cmd.Parameters.Add(new SqlParameter("@GroupName", 
                        System.Data.SqlDbType.VarChar, 50));
                    cmd.Parameters[1].Value = groupName;

                    SqlContext.Pipe.ExecuteAndSend(cmd); 

                }
            }
            catch (Exception ex)
            {
                // This error will get sent, rather than the other, 
                // to suppress this, comment out the next line.
                SqlContext.Pipe.Send
                    ("An exception occurred during the execution of RaisingErrors " 
                    + ex.ToString());

            } 


        }
        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void InsertingData(System.Data.SqlTypes.SqlString departmentName, System.Data.SqlTypes.SqlString groupName)
        {
            using (SqlConnection conn = new SqlConnection("context connection=true"))
            {
                conn.Open();
                string sql = "INSERT INTO HumanResources.Department" + 
                    "(Name, GroupName) VALUES ('" + 
                    departmentName.ToString() + "', '" + 
                    groupName.ToString() +  "')";

                SqlCommand cmd = new SqlCommand(sql, conn);
                cmd.ExecuteNonQuery();
            }

        }


        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void UpdatingData(System.Data.SqlTypes.SqlString departmentName, System.Data.SqlTypes.SqlString groupName)
        {
            using (SqlConnection conn = new SqlConnection("context connection=true"))
            {
                conn.Open();

                string sql = "UPDATE HumanResources.Department SET GroupName = '" + groupName.ToString() + "' WHERE Name = '" + departmentName.ToString() + "'";

                SqlCommand cmd = new SqlCommand(sql, conn);
                cmd.ExecuteNonQuery();
            }

        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void DeletingData(System.Data.SqlTypes.SqlString departmentName)
        {
            using (SqlConnection conn = new SqlConnection("context connection=true"))
            {
                conn.Open();

                string sql = "DELETE FROM HumanResources.Department WHERE Name = '" + departmentName.ToString() + "'";

                SqlCommand cmd = new SqlCommand(sql, conn);
                cmd.ExecuteNonQuery();
            }

        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void UsingTransaction
            (System.Data.SqlTypes.SqlString departmentName, 
            System.Data.SqlTypes.SqlString groupName)
        {
            try
            {
                using (SqlConnection conn = new SqlConnection
                    ("context connection=true"))
                {
                    conn.Open();
                    string sql = "SET NOCOUNT ON ";
                    sql += "DECLARE @DepartmentID int, @LocalError int, @LocalRows int ";
                    sql += "BEGIN TRANSACTION ";
                    sql += "INSERT INTO HumanResources.Department(Name, GroupName) ";
                    sql += "VALUES (@DepartmentName, @GroupName) ";
                    sql += "SELECT @LocalError = @@Error, @LocalRows = @@RowCount ";
                    sql += "IF NOT @LocalError = 0 or @LocalRows = 0 ";
                    sql += "    BEGIN ";
                    sql += "        ROLLBACK TRANSACTION ";
                    sql += "        SELECT DepartmentID = Null, Error = @LocalError, ";
                    sql += "        NumRows = @LocalRows ";
                    sql += "    END ";
                    sql += "ELSE ";
                    sql += "    BEGIN ";
                    sql += "        COMMIT TRAN ";
                    sql += "    	SELECT @DepartmentID = @@Identity ";
                    sql += "        SELECT DepartmentID = @DepartmentID, ";
                    sql += "        Error = 0, NumRows = @LocalRows ";
                    sql += "    END ";

                    SqlCommand cmd = new SqlCommand(sql, conn);
                    cmd.Parameters.Add(new SqlParameter
                        ("@DepartmentName", System.Data.SqlDbType.VarChar, 50));
                    cmd.Parameters[0].Value = departmentName;
                    cmd.Parameters.Add(new SqlParameter
                        ("@GroupName", System.Data.SqlDbType.VarChar, 50));
                    cmd.Parameters[1].Value = groupName;

                    SqlContext.Pipe.ExecuteAndSend(cmd);

                }
            }
            catch (Exception ex)
            {
                // This error will get sent, rather than the other, 
                // to suppress this, comment out the next line.
                SqlContext.Pipe.Send("Transaction Rolled Back");

            } 
  

        }

    }

